import { AppSyncAuthConfiguration, FeatureFlagProvider, TransformerPluginProvider, TransformHostProvider } from '@aws-amplify/graphql-transformer-interfaces';
import { ResolverConfig, TransformConfig } from '../config/transformer-config';
import Template, { DeploymentResources, UserDefinedSlot, OverrideConfig } from './types';
export interface GraphQLTransformOptions {
    readonly transformers: TransformerPluginProvider[];
    readonly stackMapping?: StackMapping;
    readonly transformConfig?: TransformConfig;
    readonly authConfig?: AppSyncAuthConfiguration;
    readonly buildParameters?: Record<string, any>;
    readonly stacks?: Record<string, Template>;
    readonly featureFlags?: FeatureFlagProvider;
    readonly host?: TransformHostProvider;
    readonly sandboxModeEnabled?: boolean;
    readonly userDefinedSlots?: Record<string, UserDefinedSlot[]>;
    readonly resolverConfig?: ResolverConfig;
    readonly overrideConfig?: OverrideConfig;
}
export declare type StackMapping = {
    [resourceId: string]: string;
};
export declare class GraphQLTransform {
    private readonly options;
    private transformers;
    private stackMappingOverrides;
    private app;
    private transformConfig;
    private readonly authConfig;
    private readonly resolverConfig?;
    private readonly buildParameters;
    private readonly userDefinedSlots;
    private readonly overrideConfig?;
    private seenTransformations;
    constructor(options: GraphQLTransformOptions);
    transform(schema: string): DeploymentResources;
    private applyOverride;
    private generateGraphQlApi;
    private synthesize;
    private collectResolvers;
    private transformObject;
    private transformField;
    private transformArgument;
    private transformInterface;
    private transformScalar;
    private transformUnion;
    private transformEnum;
    private transformEnumValue;
    private transformInputObject;
    private transformInputField;
}
//# sourceMappingURL=transform.d.ts.map