export default interface Template {
    AWSTemplateFormatVersion?: string;
    Description?: string;
    Metadata?: Record<string, any>;
    Parameters?: Record<string, any>;
    Mappings?: {
        [key: string]: {
            [key: string]: Record<string, string | number | string[]>;
        };
    };
    Conditions?: Record<string, any>;
    Transform?: any;
    Resources?: Record<string, any>;
    Outputs?: Record<string, any>;
}
export interface NestedStacks {
    rootStack: Template;
    stacks: Record<string, Template>;
    stackMapping: Record<string, string>;
}
export declare type StringMap = Record<string, string>;
export declare type ResolverMap = StringMap;
export declare type PipelineFunctionMap = StringMap;
export interface ResolversFunctionsAndSchema {
    resolvers: ResolverMap;
    pipelineFunctions: PipelineFunctionMap;
    functions: Record<string, string>;
    schema: string;
}
export interface StackMapping {
    [resourceId: string]: string;
}
export interface DeploymentResources extends ResolversFunctionsAndSchema, NestedStacks {
    stackMapping: StackMapping;
}
export declare type UserDefinedSlot = {
    resolverTypeName: string;
    resolverFieldName: string;
    slotName: string;
    requestResolver?: UserDefinedResolver;
    responseResolver?: UserDefinedResolver;
};
export declare type UserDefinedResolver = {
    fileName: string;
    template: string;
};
export declare type OverrideConfig = {
    overrideFlag: boolean;
    overrideDir: string;
    resourceName: string;
};
//# sourceMappingURL=types.d.ts.map