import { GraphQLAPIProvider, TransformerResourceHelperProvider, ModelFieldMap } from '@aws-amplify/graphql-transformer-interfaces';
import { StackManager } from './stack-manager';
export declare class TransformerResourceHelper implements TransformerResourceHelperProvider {
    #private;
    private stackManager;
    private api?;
    constructor(stackManager: StackManager);
    generateTableName: (modelName: string) => string;
    generateIAMRoleName: (name: string) => string;
    bind(api: GraphQLAPIProvider): void;
    setModelNameMapping: (modelName: string, mappedName: string) => void;
    getModelNameMapping: (modelName: string) => string;
    isModelRenamed: (modelName: string) => boolean;
    getModelFieldMap: (modelName: string) => ModelFieldMap;
    getFieldNameMapping: (modelName: string, fieldName: string) => string;
    getModelFieldMapKeys: () => string[];
    private ensureEnv;
}
//# sourceMappingURL=resource-helper.d.ts.map